<html>
<head>
<title>OGRE: OgreHardwareBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreHardwareBuffer.h</h1><a href="OgreHardwareBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __HardwareBuffer__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __HardwareBuffer__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00068"></a><a class="code" href="classOgre_1_1HardwareBuffer.html">00068</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a> 
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070 
<a name="l00071"></a>00071         <span class="keyword">public</span>:
<a name="l00073"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">00073</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> 
<a name="l00074"></a>00074             {
<a name="l00078"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466306f26f67ab31d60248314c9c6c77c9edb">00078</a>                 HBU_STATIC = 1,
<a name="l00084"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630bec61c14b13652a06566a79afd6f7518">00084</a>                 HBU_DYNAMIC = 2,
<a name="l00091"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466302fe20ff00e9acb928a2d9680f0c505e2">00091</a>                 HBU_WRITE_ONLY = 4,
<a name="l00100"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630246699879ba7647973a2d8ed86acf76f">00100</a>                 HBU_DISCARDABLE = 8,
<a name="l00102"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466305ffbb339becd31435c5f616be4c28996">00102</a>                 HBU_STATIC_WRITE_ONLY = 5, 
<a name="l00108"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630a0c82d1b27d6cc04e4b5f6d47a22a74c">00108</a>                 HBU_DYNAMIC_WRITE_ONLY = 6,
<a name="l00110"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec4663029ff2e0fd2b408359e84291b27282516">00110</a>                 HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113             };
<a name="l00115"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">00115</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a>
<a name="l00116"></a>00116             {
<a name="l00118"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0fe11601d29cd56aad7ea7a1b23a688b0e">00118</a>                 HBL_NORMAL,
<a name="l00123"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f176ad39ac15fc0a6028d820a6fe228ae">00123</a>                 HBL_DISCARD,
<a name="l00127"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0fa364c1511514cd4d7ee1e7092eb41288">00127</a>                 HBL_READ_ONLY,
<a name="l00131"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f32a2f7b1c3430cc9c3f0f665934d0c4a">00131</a>                 HBL_NO_OVERWRITE
<a name="l00132"></a>00132                 
<a name="l00133"></a>00133             };
<a name="l00134"></a>00134         <span class="keyword">protected</span>:
<a name="l00135"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a8fecea9221ffacaae2f1fdea38558da">00135</a>             <span class="keywordtype">size_t</span> mSizeInBytes;
<a name="l00136"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#2eb83f024781415a7fefb31f65a255c2">00136</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> mUsage;
<a name="l00137"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#25edb91791e48a7cc9ba2fb05f11bd33">00137</a>             <span class="keywordtype">bool</span> mIsLocked;
<a name="l00138"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#272cf9751affd73ea03930153357930b">00138</a>             <span class="keywordtype">size_t</span> mLockStart;
<a name="l00139"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#c96a7a04f4e29d8d00117a80d9a1c9a0">00139</a>             <span class="keywordtype">size_t</span> mLockSize;
<a name="l00140"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#f97b321278124803d13b700a46657ecb">00140</a>             <span class="keywordtype">bool</span> mSystemMemory;
<a name="l00141"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#2caed02d4c9ad400d020ea8b0b24adf4">00141</a>             <span class="keywordtype">bool</span> mUseShadowBuffer;
<a name="l00142"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#01ef9e872aec8bb74b75be1aff787c8f">00142</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>* mpShadowBuffer;
<a name="l00143"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#68127e87e132304c7655df554a82110c">00143</a>             <span class="keywordtype">bool</span> mShadowUpdated;
<a name="l00144"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#47e53af2e87624c42ab934766bf65fca">00144</a>             <span class="keywordtype">bool</span> mSuppressHardwareUpdate;
<a name="l00145"></a>00145             
<a name="l00147"></a>00147             <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options) = 0;
<a name="l00149"></a>00149             <span class="keyword">virtual</span> <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <span class="keyword">public</span>:
<a name="l00153"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#43c79e8e2fa85a83f800214b3661bbbf">00153</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>(<a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> usage, <span class="keywordtype">bool</span> systemMemory, <span class="keywordtype">bool</span> useShadowBuffer) 
<a name="l00154"></a>00154                 : mUsage(usage), mIsLocked(false), mSystemMemory(systemMemory), 
<a name="l00155"></a>00155                 mUseShadowBuffer(useShadowBuffer), mpShadowBuffer(NULL), mShadowUpdated(false), 
<a name="l00156"></a>00156                 mSuppressHardwareUpdate(false) 
<a name="l00157"></a>00157             {
<a name="l00158"></a>00158                 <span class="comment">// If use shadow buffer, upgrade to WRITE_ONLY on hardware side</span>
<a name="l00159"></a>00159                 <span class="keywordflow">if</span> (useShadowBuffer &amp;&amp; usage == HBU_DYNAMIC)
<a name="l00160"></a>00160                 {
<a name="l00161"></a>00161                     mUsage = HBU_DYNAMIC_WRITE_ONLY;
<a name="l00162"></a>00162                 }
<a name="l00163"></a>00163                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (useShadowBuffer &amp;&amp; usage == HBU_STATIC)
<a name="l00164"></a>00164                 {
<a name="l00165"></a>00165                     mUsage = HBU_STATIC_WRITE_ONLY;
<a name="l00166"></a>00166                 }
<a name="l00167"></a>00167             }
<a name="l00168"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#2514db557f1562eef2b7a70a1b2d8344">00168</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>() {}
<a name="l00175"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#b1caebda1f7442706df97531c2d90aaf">00175</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lock(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options)
<a name="l00176"></a>00176             {
<a name="l00177"></a>00177                 assert(!isLocked() &amp;&amp; <span class="stringliteral">"Cannot lock this buffer, it is already locked!"</span>);
<a name="l00178"></a>00178                 <span class="keywordtype">void</span>* ret;
<a name="l00179"></a>00179                 <span class="keywordflow">if</span> (mUseShadowBuffer)
<a name="l00180"></a>00180                 {
<a name="l00181"></a>00181                     <span class="keywordflow">if</span> (options != HBL_READ_ONLY)
<a name="l00182"></a>00182                     {
<a name="l00183"></a>00183                         <span class="comment">// we have to assume a read / write lock so we use the shadow buffer</span>
<a name="l00184"></a>00184                         <span class="comment">// and tag for sync on unlock()</span>
<a name="l00185"></a>00185                         mShadowUpdated = <span class="keyword">true</span>;
<a name="l00186"></a>00186                     }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188                     ret = mpShadowBuffer-&gt;lock(offset, length, options);
<a name="l00189"></a>00189                 }
<a name="l00190"></a>00190                 <span class="keywordflow">else</span>
<a name="l00191"></a>00191                 {
<a name="l00192"></a>00192                     <span class="comment">// Lock the real buffer if there is no shadow buffer </span>
<a name="l00193"></a>00193                     ret = lockImpl(offset, length, options);
<a name="l00194"></a>00194                     mIsLocked = <span class="keyword">true</span>;
<a name="l00195"></a>00195                 }
<a name="l00196"></a>00196                 mLockStart = offset;
<a name="l00197"></a>00197                 mLockSize = length;
<a name="l00198"></a>00198                 <span class="keywordflow">return</span> ret;
<a name="l00199"></a>00199             }
<a name="l00200"></a>00200 
<a name="l00205"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#93b204642190e611bc226ea08d29160e">00205</a>             <span class="keywordtype">void</span>* lock(<a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options)
<a name="l00206"></a>00206             {
<a name="l00207"></a>00207                 <span class="keywordflow">return</span> this-&gt;lock(0, mSizeInBytes, options);
<a name="l00208"></a>00208             }
<a name="l00221"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757">00221</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> unlock(<span class="keywordtype">void</span>)
<a name="l00222"></a>00222             {
<a name="l00223"></a>00223                 assert(isLocked() &amp;&amp; <span class="stringliteral">"Cannot unlock this buffer, it is not locked!"</span>);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225                 <span class="comment">// If we used the shadow buffer this time...</span>
<a name="l00226"></a>00226                 <span class="keywordflow">if</span> (mUseShadowBuffer &amp;&amp; mpShadowBuffer-&gt;isLocked())
<a name="l00227"></a>00227                 {
<a name="l00228"></a>00228                     mpShadowBuffer-&gt;unlock();
<a name="l00229"></a>00229                     <span class="comment">// Potentially update the 'real' buffer from the shadow buffer</span>
<a name="l00230"></a>00230                     _updateFromShadow();
<a name="l00231"></a>00231                 }
<a name="l00232"></a>00232                 <span class="keywordflow">else</span>
<a name="l00233"></a>00233                 {
<a name="l00234"></a>00234                     <span class="comment">// Otherwise, unlock the real one</span>
<a name="l00235"></a>00235                     unlockImpl();
<a name="l00236"></a>00236                     mIsLocked = <span class="keyword">false</span>;
<a name="l00237"></a>00237                 }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239             }
<a name="l00240"></a>00240 
<a name="l00247"></a>00247             <span class="keyword">virtual</span> <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest) = 0;
<a name="l00256"></a>00256             <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00257"></a>00257                     <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>) = 0;
<a name="l00258"></a>00258 
<a name="l00269"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#721891f0c0bd391dd5848c8a585ba054">00269</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyData(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>&amp; srcBuffer, <span class="keywordtype">size_t</span> srcOffset, 
<a name="l00270"></a>00270                 <span class="keywordtype">size_t</span> dstOffset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>)
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272                 <span class="keyword">const</span> <span class="keywordtype">void</span> *srcData = srcBuffer.<a class="code" href="classOgre_1_1HardwareBuffer.html#b1caebda1f7442706df97531c2d90aaf" title="Lock the buffer for (potentially) reading / writing.">lock</a>(
<a name="l00273"></a>00273                     srcOffset, length, HBL_READ_ONLY);
<a name="l00274"></a>00274                 this-&gt;writeData(dstOffset, length, srcData, discardWholeBuffer);
<a name="l00275"></a>00275                 srcBuffer.<a class="code" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock</a>();
<a name="l00276"></a>00276             }
<a name="l00277"></a>00277 
<a name="l00279"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#344c52f2214eaff097d5fbc390e7684b">00279</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateFromShadow(<span class="keywordtype">void</span>)
<a name="l00280"></a>00280             {
<a name="l00281"></a>00281                 <span class="keywordflow">if</span> (mUseShadowBuffer &amp;&amp; mShadowUpdated &amp;&amp; !mSuppressHardwareUpdate)
<a name="l00282"></a>00282                 {
<a name="l00283"></a>00283                     <span class="comment">// Do this manually to avoid locking problems</span>
<a name="l00284"></a>00284                     <span class="keyword">const</span> <span class="keywordtype">void</span> *srcData = mpShadowBuffer-&gt;lockImpl(
<a name="l00285"></a>00285                         mLockStart, mLockSize, HBL_READ_ONLY);
<a name="l00286"></a>00286                     <span class="comment">// Lock with discard if the whole buffer was locked, otherwise normal</span>
<a name="l00287"></a>00287                     <a class="code" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> lockOpt;
<a name="l00288"></a>00288                     <span class="keywordflow">if</span> (mLockStart == 0 &amp;&amp; mLockSize == mSizeInBytes)
<a name="l00289"></a>00289                         lockOpt = HBL_DISCARD;
<a name="l00290"></a>00290                     <span class="keywordflow">else</span>
<a name="l00291"></a>00291                         lockOpt = HBL_NORMAL;
<a name="l00292"></a>00292                     
<a name="l00293"></a>00293                     <span class="keywordtype">void</span> *destData = this-&gt;lockImpl(
<a name="l00294"></a>00294                         mLockStart, mLockSize, lockOpt);
<a name="l00295"></a>00295                     <span class="comment">// Copy shadow to real</span>
<a name="l00296"></a>00296                     memcpy(destData, srcData, mLockSize);
<a name="l00297"></a>00297                     this-&gt;unlockImpl();
<a name="l00298"></a>00298                     mpShadowBuffer-&gt;unlockImpl();
<a name="l00299"></a>00299                     mShadowUpdated = <span class="keyword">false</span>;
<a name="l00300"></a>00300                 }
<a name="l00301"></a>00301             }
<a name="l00302"></a>00302 
<a name="l00304"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#1b1b5faf06139040824fd989d0b279f8">00304</a>             <span class="keywordtype">size_t</span> getSizeInBytes(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSizeInBytes; }
<a name="l00306"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#0e00770f5e9395e41b6520be8421a6c8">00306</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> getUsage(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUsage; }
<a name="l00308"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#61086322fba08abadf4fe6734a7c70f7">00308</a>             <span class="keywordtype">bool</span> isSystemMemory(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSystemMemory; }
<a name="l00310"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#d523887cfaa6abe48dd494a3ea06805a">00310</a>             <span class="keywordtype">bool</span> hasShadowBuffer(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseShadowBuffer; }
<a name="l00312"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#3d5a62cbd76fc2ecd4e1a540bac5f9bc">00312</a>             <span class="keywordtype">bool</span> isLocked(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ 
<a name="l00313"></a>00313                 <span class="keywordflow">return</span> mIsLocked || (mUseShadowBuffer &amp;&amp; mpShadowBuffer-&gt;isLocked()); 
<a name="l00314"></a>00314             }
<a name="l00316"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#688e1be4a913099ce5e06172771e2d45">00316</a>             <span class="keywordtype">void</span> suppressHardwareUpdate(<span class="keywordtype">bool</span> suppress) {
<a name="l00317"></a>00317                 mSuppressHardwareUpdate = suppress;
<a name="l00318"></a>00318                 <span class="keywordflow">if</span> (!suppress)
<a name="l00319"></a>00319                     _updateFromShadow();
<a name="l00320"></a>00320             }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325             
<a name="l00326"></a>00326     };
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330 
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:51 2008
</p>
</body>
</html>
